<!DOCTYPE html>
<html lang="en">
  <head>
    <title>SwiftObject  Reference</title>
    <link rel="stylesheet" type="text/css" href="css/jazzy.css" />
    <link rel="stylesheet" type="text/css" href="css/highlight.css" />
    <meta charset='utf-8'>
    <script src="js/jquery.min.js" defer></script>
    <script src="js/jazzy.js" defer></script>
    
  </head>
  <body>
    <a title="SwiftObject  Reference"></a>
    <header>
      <div class="content-wrapper">
        <p><a href="index.html">SwiftObject Docs</a> (94% documented)</p>
      </div>
    </header>
    <div class="content-wrapper">
      <p id="breadcrumbs">
        <a href="index.html">SwiftObject Reference</a>
        <img id="carat" src="img/carat.png" />
        SwiftObject  Reference
      </p>
    </div>
    <div class="content-wrapper">
      <nav class="sidebar">
        <ul class="nav-groups">
          <li class="nav-group-name">
            <a href="Classes.html">Classes</a>
            <ul class="nav-group-tasks">
              <li class="nav-group-task">
                <a href="Classes/Object.html">Object</a>
              </li>
              <li class="nav-group-task">
                <a href="Classes/Object/Status.html">– Status</a>
              </li>
            </ul>
          </li>
          <li class="nav-group-name">
            <a href="Structs.html">Structures</a>
            <ul class="nav-group-tasks">
              <li class="nav-group-task">
                <a href="Structs/Box.html">Box</a>
              </li>
            </ul>
          </li>
          <li class="nav-group-name">
            <a href="Typealiases.html">Type Aliases</a>
            <ul class="nav-group-tasks">
              <li class="nav-group-task">
                <a href="Typealiases.html#/s:11SwiftObject0B8Functiona">ObjectFunction</a>
              </li>
              <li class="nav-group-task">
                <a href="Typealiases.html#/s:11SwiftObject0B8Variablea">ObjectVariable</a>
              </li>
            </ul>
          </li>
        </ul>
      </nav>
      <article class="main-content">
        <section>
          <section class="section">
            
            <h1 id='swiftobject' class='heading'>SwiftObject</h1>
<h3 id='creating-an-object' class='heading'>Creating an Object</h3>
<pre class="highlight plaintext"><code>var obj = Object()
</code></pre>
<h3 id='example-variables' class='heading'>Example Variables</h3>
<pre class="highlight plaintext"><code>func testVariableExample1() {
    // Assign the Object's Single Variable
    obj &lt;~~ "Hello World"
    // Assign four different type keys Variables with values
    obj &lt;~~ ["Hello World": 123,
    5: "Hi",
    3.14: "pi",
    UIColor.blue: "blue"]

    // Check that the Object's Single Variable is "Hello World"
    XCTAssert("\(obj~~&gt;)" == "Hello World")
    // Cast the Variable Hello World to Int and checks that it is 123
    XCTAssert(obj ~~&gt; ("Hello World", Int.self) ?? 0 == 123)
    // Cast the Variable 5 to String and checks that it is "Hi"
    XCTAssert(obj ~~&gt; (5, String.self) ?? "" == "Hi")
    // Cast the Variable 3.14 to String and checks that it is "pi"
    XCTAssert(obj ~~&gt; (3.14, String.self) ?? "" == "pi")
    // Cast the Variable UIColor.blue to String and checks that it is "blue"
    XCTAssert(obj ~~&gt; (UIColor.blue, String.self) ?? "" == "blue")
}

func testVariableExample2() {
    // Assign four Variables with different value types
    obj &lt;~~ ["pi": 3.14,
            "foo": "bar",
            "childObj": Object(),
            "count": 0]

    // Assign the Variable childObj's Single Variable to 135
    (obj ~~&gt; ("childObj", Object.self))! &lt;~~ 135

    // guard unwrap of the Variables with as? Type style
    guard let pi = obj ~~&gt; "pi" as? Double,
            let foo = obj ~~&gt; "foo" as? String,
            let childObj = obj ~~&gt; "childObj" as? Object,
            let childObjValue = childObj~~&gt; as? Int,
            let count = obj ~~&gt; "count" as? Int else {
                XCTFail()
                return
    }

    // Check values
    XCTAssert(pi == 3.14)
    XCTAssert(foo == "bar")
    XCTAssert(childObjValue == 135)
    XCTAssert(count == 0)
}

func testVariableExample3() {
    // Assign four Variables with different value types
    obj &lt;~~ ["pi": 3.14,
            "foo": "bar",
            "childObj": Object(),
            "count": 0]

    // Assign the Variable childObj's Single Variable to 136
    (obj ~~&gt; ("childObj", Object.self))! &lt;~~ 136

    // guard unwrap of the Variables with &lt;E.Type&gt; Style
    guard let pi = obj ~~&gt; ("pi", Double.self),
            let foo = obj ~~&gt; ("foo", String.self),
            let childObj = obj ~~&gt; ("childObj", Object.self),
            let childObjValue = childObj ~~&gt; Int.self,
            let count = obj ~~&gt; ("count", Int.self) else {
                XCTFail()
                return
    }

    // Check values
    XCTAssert(pi == 3.14)
    XCTAssert(foo == "bar")
    XCTAssert(childObjValue == 136)
    XCTAssert(count == 0)
}

func testVariableExample4() {
    // Assign Variables
    obj &lt;~~ ["a": 1,
            "child": Object(),
            "b": 2]

    // Check values
    XCTAssert(obj ~~&gt; ("a", Int.self) == 1)
    XCTAssert(obj ~~&gt; ("b", Int.self) == 2)

    // Unwrap as Object
    guard let child = obj ~~&gt; ("child", Object.self) else {
        XCTFail()
        return
    }
    // Store info into a local var
    child &lt;~~ ["hello": "world",
                "a": 2]
    // Retrieve child from parent
    guard let pchild = obj ~~&gt; ("child", Object.self) else {
        XCTFail()
        return
    }
    // Check values
    XCTAssert(pchild ~~&gt; ("a", Int.self) == 2)
    XCTAssert(pchild ~~&gt; ("hello", String.self) == "world")
}

func testVariableExample5() {
    // Add the Object to the Object's Single Variable
    obj &lt;~~ obj

    // Grab obj's Single Variable
    let one = obj ~~&gt; Object.self ?? Object()
    // Grab one's Single Variable
    let two = one ~~&gt; Object.self ?? Object()
    // Grab two's Single Variable
    let three = two ~~&gt; Object.self ?? Object()
    let n = 100
    // Grab n's Single Variable
    var n_obj: Object = obj
    (1 ... n).forEach { i in
        n_obj = (n_obj ~~&gt; Object.self)!
    }
    // Check values
    XCTAssert(one == two &amp;&amp;
                two == three)
    XCTAssert(obj == n_obj &amp;&amp;
                one == n_obj &amp;&amp;
                two == n_obj &amp;&amp;
                three == n_obj)
}
</code></pre>
<h3 id='example-functions' class='heading'>Example Functions</h3>
<pre class="highlight plaintext"><code>func testFunctionExample1() {
        obj &lt;^ ["isEven": { value in
                guard let i = value as? String else {
                return "ERROR: Could not parse \(value) to type String"
                }
                return i.count % 2 == 0
        }]
 func testFunctionExample1() {
     // Create function isEven(value: String) -&gt; Bool
     obj &lt;^ ["isEven": { value in
         // Cast value as String
         guard let i = value as? String else {
             // Return TypeError
             return ~~&gt;.TypeError
         }
         // Check if i is even
         return i.count % 2 == 0
     }]

     // Assign the function isEven to a local variable named isEven
     let isEven = obj ^&gt; "isEven"

     // Check values
     XCTAssert(isEven(12345) is Object.Status)
     XCTAssertFalse(isEven("Hello World") as! Bool)
     XCTAssertFalse(isEven("12345") as! Bool)
     XCTAssertFalse(isEven("1") as! Bool)
     XCTAssert(isEven("1234") as! Bool)
     XCTAssert(isEven("") as! Bool)
 }

        let isEven = obj ^&gt; "isEven"

        XCTAssert("\(isEven(12345))".contains("ERROR:"))
        XCTAssertFalse(isEven("Hello World") as! Bool)
        XCTAssertFalse(isEven("12345") as! Bool)
        XCTAssertFalse(isEven("1") as! Bool)
        XCTAssert(isEven("1234") as! Bool)
        XCTAssert(isEven("") as! Bool)
}
func testFunctionExample2() {
    // Assign Variables
    obj &lt;~~ 1000
    obj &lt;~~ ["sum": 0]

    // Assigning the Object's Single Function (Int) -&gt; Int
    obj &lt;^ { value in
        // Cast value to Int and grab obj's Single Variable
        guard let i = value as? Int,
            let inc = self.obj ~~&gt; Int.self else {
            return ~~&gt;.TypeError
        }
        return i + inc
    }

    // Assign the Single Function to a local variable named add
    let add = obj^&gt;

    // Assign sum to the output of add(5)
    obj &lt;~~ ["sum": add(5)]

    // Check values
    XCTAssert(obj ~~&gt; ("sum", Int.self) ?? 0 == 1005)
    XCTAssert(obj &lt;~&gt; ("", "sum") as! Int == 2005)
}

func testFunctionExample3() {
    // Assign Variables
    obj &lt;~~ "xyz"
    obj &lt;~~ [56: "SwiftObject",
    UIColor.orange: 133]

    // Assign Function named sayHello
    obj &lt;^ ["sayHello": { _ in
        return "Hello World"
    }]

    // Assign three different Functions
    obj &lt;^ [100: { _ in 100 },
            UIColor.yellow: { iValue in "[\(iValue ?? "")]" },
            "color": { _ in UIColor.black }]
    // Assign Single Function
    obj &lt;^ { v in 27 }

    // Check values
    XCTAssert(obj &lt;^&gt; (UIColor.yellow, "YELLOW") as? String ?? "" == "[YELLOW]")
    XCTAssert(obj &lt;&gt; "color" as? UIColor ?? .clear == .black)
    XCTAssert(obj &lt;~&gt; (UIColor.yellow, UIColor.orange) as? String ?? "" == "[\(133)]")
    XCTAssert(obj &lt;~&gt; UIColor.orange as? Int ?? 0 == 27)
    XCTAssert(obj &lt;&gt; 100 as? Int ?? 0 == 100)
    XCTAssert("\(obj &lt;&gt; "sayHello" ?? "")" == "Hello World")
}

func testFunctionExample4() {
    // Assign Single Variable to 0
    obj &lt;~~ 0
    // Create Functions
    obj &lt;^ ["add": { i in (self.obj ~~&gt; Int.self)! + (i as? Int)!},
    "sub": { i in (self.obj ~~&gt; Int.self)!  - (i as? Int)!}]
    // Update Single Variable
    obj &lt;~~ obj &lt;^&gt; ("add",23)
    obj &lt;~~ obj &lt;^&gt; ("add",343)
    obj &lt;~~ obj &lt;^&gt; ("sub",421)
    // Check final value
    XCTAssert(obj ~~&gt; Int.self == -55)
}

func testFunctionExample5() {
    // Assign Single Variable to 0
    obj &lt;~~ 0
    // Assign Single Function
    obj &lt;^ { inc in
        return self.obj &lt;~~ ((self.obj ~~&gt; Int.self)! + (inc as! Int))
    }
    let inc = obj^&gt;
    _ = inc(5)
    _ = inc(8)
    _ = inc(3)
    // Using Run Runes
    // run Single Function with the Single Variable passed as a parameter
    _ = obj&lt;~&gt;
    // run Single Function with different Int values
    _ = obj &lt;^&gt; 6
    _ = obj &lt;^&gt; 4

    // Check values
    XCTAssert(obj ~~&gt; Int.self == 42)
}

// Recursion Test
func testFunctionExample6() {
    // Assign Variable beersOnTheWall to 99
    obj &lt;~~ ["beersOnTheWall": 99]
    // Assign Single Function
    obj &lt;^ { _ in
        // Unwrap beersOnTheWall
        guard let beersOnTheWall = self.obj ~~&gt; ("beersOnTheWall", Int.self) else {
            XCTFail()
            return nil
        }
        // Check if beersOnTheWall is 0
        if beersOnTheWall == 0 {
            // End Recursion
            return "Oops no more beer on the wall!"
        }
        // Assign beersOnTheWall to beersOnTheWall - 1
        self.obj &lt;~~ ["beersOnTheWall": beersOnTheWall - 1]
        // Start Recursion
        return self.obj&lt;&gt;
    }
    // Check that beersOnTheWall is 99
    XCTAssert(obj ~~&gt; ("beersOnTheWall", Int.self) == 99)
    // Call Single Function
    _ = obj&lt;&gt;
    // Check that beersOnTheWall is 0
    XCTAssert(obj ~~&gt; ("beersOnTheWall", Int.self) == 0)
}

func testA() {
    // Assign Single Function (Int) -&gt; [Int]
    obj &lt;^ { i in
        // Unwrap as Int
        guard let j = i as? Int else {
            return ~~&gt;.TypeError
        }
        // Create [Int] of length j + 1
        return (0 ... j).map({ $0 + ($0+j)} )
    }
    // Create local variable of the Single Function
    let splat = obj^&gt;
    // Unwrap as [Int]
    guard let value = splat(5) as? [Int] else {
        XCTFail()
        return
    }
    // Check values
    XCTAssert(value == [5, 7, 9, 11, 13, 15])
}

func testB() {
    // Assign Variable
    obj &lt;~~ ["apple": 123]
    // Assign Single Function
    obj &lt;^ { i in print(i) }

    // Use Runes
    _ = obj &lt;^&gt; "Hello World"

    _ = obj&lt;&gt;

    _ = obj &lt;~&gt; "apple"
    // Quick Unwrap value
    let value: Int = obj ~~&gt; ("apple", Int.self) ?? 0
    // Check value
    XCTAssert(value == 123)
}

func testC() {
    // Object Builder
    obj &lt;^ { _ in
        // Assign Single Variable to 0
        self.obj &lt;~~ 0
        // Create Function inc (Int) -&gt; Int
        self.obj &lt;^ ["inc": { i in
            guard let i = i as? Int else {
                return ~~&gt;.TypeError
            }
            return i + 1
        }]
        // Assign the Single Function to a new function
        self.obj &lt;^ { _ in
            return self.obj &lt;~~ self.obj &lt;~&gt; ("inc","") ?? -1
        }
        // Return a Completed Function Status
        return ~~&gt;.Completed
    }
    // Run the Single Function 11 times
    _ = (0 ... 9).map({ _ in obj&lt;&gt; })
    _ = obj&lt;~&gt;
    // Check values
    XCTAssert(obj ~~&gt; Int.self == 10)
}
</code></pre>

<p>Thanks for the amazing docs <a href="https://github.com/realm/jazzy">Jazzy!</a></p>

          </section>
        </section>
        <section id="footer">
          <p>&copy; 2018 <a class="link" href="https://gitlab.com/_leif/SwiftObject" target="_blank" rel="external">Zach Eriksen</a>. All rights reserved. (Last updated: 2018-09-05)</p>
          <p>Generated by <a class="link" href="https://github.com/realm/jazzy" target="_blank" rel="external">jazzy ♪♫ v0.9.3</a>, a <a class="link" href="https://realm.io" target="_blank" rel="external">Realm</a> project.</p>
        </section>
      </article>
    </div>
  </body>
</div>
</html>
